Unit HackUtil;
Interface
Uses Crt,Dos;

type
 CharSet           = Set of #0..#255;
 ByteArray         = Array[0..255] of Byte;

var
 CursorX,CursorY        :Byte;
 Cursor                 :Word;   { Save old cursor here }
 Screen                 :Array[0..3999] of Byte absolute $B800:$0000;

{ utils.pas fragments ... damned, they are unoptimized :-( }

Function  St(i: LongInt): String;
Procedure WaitKey;
Function  ProgramPath(const S: String): String;
Procedure Beep(hz,ms: Word);
Function  Exist(FileName: string): Boolean;
Procedure CreateFile(fil: String);
Function  Upper(S :String): String;
Function  GetINI(var FileVar: Text;INILabel,INIRecord: String): String;
Function  Va(const s: string): LongInt;
Function  RepeatChar(c: Char;n: Byte): String;
Function  KiloComma(i: LongInt): String;
Function  FileLength(fil: String): LongInt;
Function  LongWordStr(dwrd: longint): string;
Function  SpaceF(s: string;antal: byte): String;
Function  SpaceB(s: string;antal: byte): String;
Function  LZ(tal: longint;antal: byte): String;
Function  Instr(Target,Objct: STRING; StartPos: BYTE): BYTE;
Function  Left(s: String;nr: Byte ):String;
Function  Right(s :String;nr: Byte): String;
Function  Mid(S: String;nr,nr2: Byte): String;
Procedure PUpper(var s:string);
Procedure TUpper(var Source: string; var Table: ByteArray);
Function  FUpper(const S :String): String;
Function  FlipString(s: String):String;
Function  HHMMSS(Secs: LongInt): String;
Function  PadRight(Source: String;Count: Byte;PadChar: Char): String;
Function  PadLeft(Source: String;Count: Byte;PadChar: Char): String;
Procedure FlushTgbBuffer;
Function  FindFile(FileName: String): String;
Function  ScreenWidth: Byte;
Function  ScreenHeight: Byte;
Function  ExtendedKey1: Byte;
Function  Max(x,y: LongInt): LongInt;
Function  Min(x,y: LongInt): LongInt;
Procedure Delay(ms: Word);
Function  Date: String;
Function  Time: String;

{ UtilEnv fragments ... }

Function Input(X,Y: Byte;StartStr: String;BackG: Char;MaxLen,StartPos:
               Integer;AcceptSet: CharSet;Ins: Boolean;var InputStatus: Byte): String;
Procedure WriteXY(x,y: Byte;s: String);
Procedure WriteXYC(x,y,attr: Byte;s: String);
Function  CharXY(x,y: byte): byte;
Function  AttrXY(x,y: byte): byte;
Procedure SetAttrXY(x,y,attr: byte);
Procedure Centre(s: string;y: byte);
Procedure SaveScreen(var Screen: Pointer);
Procedure RecallScreen(const Screen: Pointer);
Procedure SetAttr(x,y,len,attr: Byte);
Procedure SetChar(x,y,len: byte;char: String);
Function  GetCursor: Word;                                        { HLP:10 }
Procedure SetCursor(Cursor: Word);                                { HLP:11 }
Procedure HideCursor;                                             { HLP:13 }
Procedure NormalCursor;                                           { HLP:13 }
Procedure BlockCursor;                                            { HLP:13 }
Procedure UnCrunch(var Addr1,Addr2; BlkLen:Integer);
Procedure GrayBox(X,Y,W,H: Byte;Shadow: Boolean);
Procedure GrayBox2(X,Y,W,H,HeadOfs,Attr: Byte;const Header: String; Shadow: Boolean);
Procedure InvGrayBox(X,Y,W,H: Byte);
Procedure InvGrayBox2(X,Y,W,H,HeadOfs,Attr: Byte;const Header: String);
Procedure GrayMessageBox(S: String; Y:Byte);

Procedure NCButton(nr: byte;s: string);
Procedure NCBottomLine(s1,s2,s3,s4,s5,s6,s7,s8,s9,s10: string);

Procedure ChooseAsciiSet(X,Y: Byte;var AsciiSet: String);
Procedure MessageScroller(X,Y,W,H: Byte;var ScrollText: Array of Char);
Function  AskBoolean(X,Y: Byte;Header,T1,T2: String): Boolean;

const
  CtrlHome  = #119;   CtrlPgDn = #118; CtrlPgUp = #132; CtrlEnd  = #117;
  CtrlPrtSc = #114;   ShiftTab = #15;
  CtrlLeftKey = #115; CtrlRightKey = #116;
  EndKey = #79;  PgUp   = #73;  PgDn   = #81;
  Space  = #32; UpKey  = #72;  LeftKey= #75;
  RightKey= #77; DownKey= #80;  Ins    = #82;
  Del    = #83;  Cr     = #13;  Enter  = #13;
  Esc    = #27;  Escape = #27;  Lf     = #10;
  Ff     = #12;  BackS  = #8;   Home   = #71;
  Tab    = #9;
  CtrlQ = #17;  CtrlW = #23;  CtrlE = #5;  CtrlR = #18;
  CtrlT = #20;  CtrlY = #25;  CtrlU = #21; CtrlI = #9;
  CtrlO = #15;  CtrlP = #16;  CtrlA = #1;  CtrlS = #19;
  CtrlD = #4;   CtrlF = #6;   CtrlG = #7;  CtrlH = #8;
  CtrlJ = #10;  CtrlK = #11;  CtrlL = #12; CtrlZ = #26;
  CtrlX = #24;  CtrlV = #22;  CtrlB = #2;  CtrlN = #14;
  CtrlM = #13;  CtrlC = #3;
  AltQ = #16;  AltE = #18;  AltT = #20;  AltY = #21;
  AltU = #22;  AltI = #23;  AltO = #24;  AltP = #25;
  AltA = #30;  AltS = #31;  AltD = #32;  AltF = #33;
  AltG = #34;  AltH = #35;  AltJ = #36;  AltK = #37;
  AltL = #38;  AltZ = #44;  AltC = #46;  AltV = #47;
  AltB = #48;  AltN = #49;  AltM = #50;  AltW = #17;
  AltR = #19;  AltX = #45;
  F1  = #59;  ShiftF1 = #84;  CtrlF1 = #94;  AltF1 = #104;
  F2  = #60;  ShiftF2 = #85;  CtrlF2 = #95;  AltF2 = #105;
  F3  = #61;  ShiftF3 = #86;  CtrlF3 = #96;  AltF3 = #106;
  F4  = #62;  ShiftF4 = #87;  CtrlF4 = #97;  AltF4 = #107;
  F5  = #63;  ShiftF5 = #88;  CtrlF5 = #98;  AltF5 = #108;
  F6  = #64;  ShiftF6 = #89;  CtrlF6 = #99;  AltF6 = #109;
  F7  = #65;  ShiftF7 = #90;  CtrlF7 = #100; AltF7 = #110;
  F8  = #66;  ShiftF8 = #91;  CtrlF8 = #101; AltF8 = #111;
  F9  = #67;  ShiftF9 = #92;  CtrlF9 = #102; AltF9 = #112;
  F10 = #68;  ShiftF10= #93;  CtrlF10= #103; AltF10= #113;
  F11 = #133; ShiftF11= #135; CtrlF11= #137; AltF11= #139;
  F12 = #134; ShiftF12= #136; CtrlF12= #138; AltF12= #140;

Implementation

Function St(I :LongInt): String;
var
 s:      String;
begin
 Str(I,S);
 St:=S;
end;

Procedure Waitkey;
begin
 asm
  mov ax,$0C06;
  mov dx,$00FF;
  int $21;
 end;
repeat until keypressed;
FlushTgbBuffer;
end;

Function ProgramName(const S: String): String;
var
loop:   byte;
antal:  byte;
poss:   byte;
temp:   string;
begin
temp:=S;
antal:=0;
poss:=0;
for loop:=length(temp) downto 1 do
 begin
  if temp[loop]='\' then begin
                          antal:=antal+1;
                          if antal=1 then poss:=loop;
                         end;
 end;
if antal=0 then ProgramName:=temp else
 ProgramName:=right(temp,length(temp)-poss);
{antal kan returneras fr att ange antalet directories som leder till filen}
end;

Function ProgramPath(const S: String): String;
begin
 ProgramPath:=Left(S,length(S)-Length(ProgramName(S)));
end;

Procedure Beep(hz,ms: Word);
begin
 Sound(hz);
 Delay(ms);
 NoSound;
end;

Function Exist(FileName: string): Boolean;
Var
 Dirinfo :SearchRec;
begin
 Exist:=False;
 FindFirst(FileName,Anyfile-VolumeID,DirInfo);
 if DosError=0 then exist:=True;
end;

Procedure CreateFile(fil: String);
var
 flumma:      Text;
begin
 Assign(flumma,fil);
 Rewrite(flumma);
 Close(flumma);
end;

Function Upper(s: String): String;
var
 I: Byte;
begin
  for I:=1 to Length(s) do
   begin
    if s[I]='' then s[I]:='' else
    if s[I]='' then s[I]:='' else
    if s[I]='' then s[I]:='' else s[I]:=UpCase(s[I]);
   end;
 Upper:=s;
end;

Function GetINI(var FileVar: Text;INILabel,INIRecord: String): String;
var
 Done   :Boolean;
 S      :String;
 Loop   :Word;

begin
 Reset(FileVar);
 Done:=False;
 INIRecord:=FUpper(INIRecord);
 INILabel:=FUpper(INILabel);
repeat
 ReadLn(FileVar,S);
until Eof(FileVar) or (FUpper(S)=INILabel);
 if FUpper(S)=INILabel then begin
  repeat
   ReadLn(FileVar,S);
   if (length(S)>0) and (S[1]<>';') and (Instr(S,'=',2)>0) then
    begin
     loop:=1;
     repeat
      if S[loop]=#32 then Delete(S,loop,1) else
      if S[loop]=#9  then Delete(S,loop,1) else Inc(Loop);
     Until (S[loop]='=') or (loop=Length(S));
     if Left(FUpper(S),loop)=INIRecord+'=' then Done:=True;
    end;
  until (Done) or (Eof(FileVar)) or (S[1]='[');
 end;

if Done then begin
 While (S[loop+1]=' ') and (loop+1<=Length(s)) do Delete(S,loop+1,1);
 While (S[length(s)]=' ') do Delete(S,length(S),1);
 GetINI:=Mid(S,InStr(S,'=',1)+1,Length(S));
 end else GetINI:='';
end;

Function Va(const s: string): longint;
var
 code:   Integer;
 vas:    Longint;
begin
 Val(s,vas,code);
 Va:=vas
end;

Function RepeatChar(c: Char;n: Byte): String; Assembler;
asm
 XOR    CX, CX
 MOV    AL, c
 MOV    CL, n
 LES    DI, @Result
 MOV    BYTE PTR ES:[DI], CL
 INC    DI
 CLD
 REP    STOSB
end;

Function KiloComma(i: LongInt): String;
var
 s:      String[80];
 loop:   Word;
 a:      Word;
begin
 s:=flipstring(st(i));
 a:=length(s);
  for loop:=a downto 2 do if loop mod 3=1 then Insert(',',s,loop);
 KiloComma:=FlipString(s);
end;

Function FileLength(fil: String): LongInt;
var
f:      File of byte;
fs:     LongInt;
begin
fs:=-1;
Assign(f,fil);
Reset(f);
fs:=FileSize(f);
FileLength:=fs;
Close(f);
end;

function LongWordStr(dwrd:longint):String; Assembler;
asm
 push ds
 push cs
 pop  ds
 lea bx,@tabel
 les di,@result
 cld
 mov al,8
 stosb
 mov ax,word ptr dwrd+2
 mov cx,ax
 mov dx,ax
 and dx,0f0f0h
 and cx,0f0fh
 shr dx,4
{ shr dx,1
 shr dx,1
 shr dx,1 }
 mov al,dh
 xlat
 stosb
 mov al,ch
 xlat
 stosb
 mov al,dl
 xlat
 stosb
 mov al,cl
 xlat
 stosb
 mov ax,word ptr dwrd
 mov cx,ax
 mov dx,ax
 and dx,0f0f0h
 and cx,00f0fh
 shr dx,4
{ shr dx,1
 shr dx,1
 shr dx,1 }
 mov al,dh
 xlat
 stosb
 mov al,ch
 xlat
 stosb
 mov al,dl
 xlat
 stosb
 mov al,cl
 xlat
 stosb
 pop ds
 jmp @yt
@tabel:
 db '0123456789ABCDEF'
@yt:
end;

Function SpaceF(s: string;antal: byte): String;
var
temp:   String;
loop:   Byte;
begin
temp:='';
 for loop:=1 to antal-length(s) do temp:=temp+' ';
SpaceF:=temp+s;
end;

Function SpaceB(s: string;antal: byte): String;
var
temp:   String;
loop:   Byte;
begin
temp:=s;
if length(s)>=antal then temp:=left(s,antal) else
 for loop:=1 to antal-length(s) do temp:=temp+' ';
SpaceB:=temp;
end;

Function  LZ(tal: longint;antal: byte): String;
var
 loop:   Byte;
 temp:   String[20];

begin
temp:=st(tal);
 While length(temp)<antal do temp:='0'+temp;
lz:=temp;
end;

FUNCTION Instr(Target,Objct: STRING; StartPos: BYTE): BYTE; ASSEMBLER;
ASM
{$IFOPT G+}
           PUSH    BP            { save frame pointer }
{$ENDIF}
           CLD                   { auto increment for string instructions }
           PUSH    DS            { save Turbo Pascal's data segment }
           LES     DI, [Target]  { pointer to target string }
           LDS     SI, [Objct]   { pointer to object string }
           XOR     BX, BX        { initialize }
           OR      BL, [StartPos]{  start position }
           JZ      @NoChange     { don't change when zero }
           DEC     BX            { dekrement start position }
@NoChange: LODSW                 { AL = length Object, AH = 1. char in Object }
           SUB     AL, 1         { length Object - 1 }
           JB      @NotFound1    { exit, if length-1 < 0 }
           MOV     CL, ES: [DI]  { length target String }
           MOV     CH, CL        { length traget String }
           SUB     CL, AL        { length target - length Object + 1 }
           JBE     @NotFound1    { if <= 0, exit }
           SUB     CL, BL        { remaining length Target }
           JBE     @NotFound1    { if <= 0, exit }
           INC     DI            { 1. char in Target }
           ADD     DI, BX        { start position in Target }
           XCHG    CH, BH        { BH = length target string, CH = 0 }
           XCHG    AL, AH        { AL = 1. char Object, AH = length Object }
           MOV     BP, SI        { save pointer }
@Search1:  REPNZ   SCASB         { scan target for 1st char of Object }
           JNZ     @NotFound2    { if not found, exit }
           MOV     BL, CL        { save remaining length target }
           MOV     CL, AH        { char still to compare in Object }
           MOV     DX, DI        { get offset into Target }
           REPZ    CMPSB         { compare CX chars of Target and Object }
           MOV     SI, BP        { offset into Object }
           MOV     DI, DX        { offset into Target }
           MOV     CL, BL        { remaining length Target }
           JNZ     @Search1      { continue search if no complete match }
           SUB     BH, BL        { pos = length Target - remaining len target}
           SUB     BH, AH        { pos = l. Target - rem. l. target - l. Object}
@NotFound1:MOV     CH, BH        { pos }
@NotFound2:MOV     AL, CH        { pos }
           XOR     AH, AH        { clear MSB }
           POP     DS            { restore TURBO Pascal's data segment }
{$IFOPT G+}
           POP     BP            { restore frame pointer }
{$ENDIF}
END; { Instr }

Function Left(s: String;nr: byte): String;
begin
 Delete(s,nr+1,length(s));
 Left:=s;
end;

Function Right(s: String;nr: byte): String;
begin
 Delete(s,1,length(s)-nr);
 Right:=s;
end;

Function Mid(s: String;nr,nr2: byte): String;
begin
 Delete(s,1,nr-1);
 Delete(s,nr2-nr+2,length(s));    {  USE COPY INSTEAD!}
 Mid:=s;
end;

Procedure PUpper(var s:string); assembler;
asm
  push ds
  lds  si,s
  mov  cl,[si]
  xor  ch,ch
  jcxz @Exit
  lea  dx,[si+1]
  mov  ax,$6521
  int  21h
@Exit:
  pop ds
end;

Procedure TUpper(var Source: string; var Table: ByteArray); Assembler;
asm
  mov  dx, ds       { save ds }
  lds  bx,Table     { load ds:bx with Table address }
  les  di,Source    { load es:di with Source address }
  seges             { override ds segment}
  mov  al,[di]      { load al with length of source }
  xor  ah, ah       { set ah to zero, we need a word for cx }
  mov  cx,ax        { assign length of source to counter }
  jcxz @end         { if cx = 0 exit}
  inc  di           { increment di & skip length byte on 1st pass }
@filter:
  mov  al,[di]      { load byte in ax from es:di }
  xlat              { translate... }
  mov  [di],al      { send byte to es:di }
  inc  di           { increment di }
  loop @filter      { decrement cx and loop back if cx > 0 }
@end:
  mov  ds, dx       { restore ds }
end;

Function FUpper(const S :String): String; assembler;
{ converts string S to uppercase, Function version }
asm
  push ds
  lds  si,s
  cld
  lodsb
  mov  cl,al
  xor  ch,ch
  jcxz @Exit
  les  di,@Result
  stosb
  mov  dx,di
  push cx
  rep  movsb
  push es
  pop  ds
  pop  cx
  mov  ax,$6521
  int  21h
@Exit:
  pop ds
end;

Function FlipString(s: String):String;
var
 ss:     String;
 loop:   Word;
begin
ss:='';
 for loop:=length(s) downto 1 do ss:=ss+s[loop];
FlipString:=ss;
end;

Function HHMMSS(Secs: LongInt): String;
begin
 HHMMSS:=Lz(Trunc(Secs/(60*60)),2)+':'+Lz(Trunc((Secs mod 3600)/60),2)+':'+Lz(Secs mod 60,2);
end;

Function PadRight(Source: String;Count: Byte;PadChar: Char): String;
var
 S              :String;
begin
 S:=Source;
 if Count>Length(S) then
   While Count>Length(S) do Insert(PadChar,S,Length(S)+1) else S:=Copy(Source,1,Count);
 PadRight:=S;
end;

Function PadLeft(Source: String;Count: Byte;PadChar: Char): String;
var
 S              :String;
begin
 S:=Source;
 if Count>Length(S) then
   While Count>Length(S) do Insert(PadChar,S,1) else S:=Right(Source,Count);
 PadLeft:=S;
end;

Procedure FlushTgbBuffer; Assembler;
asm
 mov ax,$0C06;
 mov dx,$00FF;
 int $21;
end;

Function FindFile(FileName: String): String;
var
 PS             :PathStr;

begin
 PS:=FSearch(FileName,GetEnv('PATH'));
 if PS>'' then FindFile:=FExpand(PS) else FindFile:='';
end;

Function ScreenWidth: Byte;
var
b:      Byte;
begin
 asm
  mov ah,$f
  int $10
  mov b,ah
 end;
ScreenWidth:=b;
end;

Function ScreenHeight: Byte;
{40:4A, 40,84}
begin
 ScreenHeight:=Mem[$40:$84];
end;

Function ExtendedKey1: Byte;
var
loop: byte;
begin
 asm
  mov ah,$12
  int $16
  mov loop,ah
 end;
ExtendedKey1:=loop;
{ 1 - Left CTRL, 2 - Left ALT, 4 - Right CTRL, 8 - Right ALT (GR)
  16- Scroll Lock, 32 - Num Lock, 64 - Caps Lock }
end;

Function Max(x,y: LongInt): LongInt;
begin
 if x>y then Max:=x else Max:=y;
end;

Function Min(x,y: LongInt): LongInt;
begin
 if x>y then Min:=y else Min:=x;
end;

Function Date: String;
var
y,m,d,dow: Word;
day,month: String[2];

begin
GetDate(y,m,d,dow);
   str(d,day);
   str(m,month);
    if length(day)=1 then day:='0'+day;
    if length(month)=1 then month:='0'+month;
date:=right(st(y),2)+'-'+month+'-'+day;
end;

Function Time: String;
var
h,m,s,hun: Word;
hour,min,sec: String[2];
begin
GetTime(h,m,s,hun);
   str(h,hour);
   str(m,min);
   str(s,sec);
    if length(hour)=1 then hour:='0'+hour;
    if length(min)=1 then min:='0'+min;
    if length(sec)=1 then sec:='0'+sec;
Time:=hour+':'+min+':'+sec;
end;


{ UtilEnv Fragments ... }

Procedure SetCharXY(x,y,Tecken: byte);
begin
 mem[$B800:(x-1)*2+(y-1)*160]:=Tecken;
end;

Function Input(X,Y: Byte;StartStr: String;BackG: Char;MaxLen,StartPos:
               Integer;AcceptSet: CharSet;Ins: Boolean;var InputStatus: Byte): String;
{Version 1.5}
Var
P:      Byte;
Exit:   Boolean;
ch:     Char;
ext:    Char;
s:      String;
t:      String[1];
begin
Exit:=False;                                      { Don't quit on me yet! }
if BackG='' then BackG:=' ';
if Length(StartStr)>MaxLen then StartStr:=Left(StartStr,MaxLen);
if StartPos>Length(StartStr) then StartPos:=Length(StartStr);
if StartPos=-1 then StartPos:=Length(StartStr);
If StartPos>=MaxLen then StartPos:=MaxLen-1;

s:=StartStr;                                { Put StartStr into Edit Buffer }
WriteXY(X,Y,RepeatChar(BackG,MaxLen));

if StartStr<>'' then WriteXY(X,Y,StartStr);

p:=StartPos;
GotoXY(X+StartPos,Y);

repeat
 if Ins then NormalCursor else BlockCursor;
 ext:=#0;
 ch:=ReadKey;
 if ch=#0 then ext:=ReadKey;
 if ch=#27 then begin
                 InputStatus:=27;
                 Exit:=True;
                end;
{   (ch<#255) and (ch>#31) }
if ch in AcceptSet then
  begin   { Welcome to the jungle...}
   t:=ch;
    if (p=length(s)) and (Length(s)<MaxLen) then
     begin
      s:=s+t;
      WriteXY(X+P,Y,T);
      Inc(p);
     end else
      if length(s)<MaxLen then
       begin
        if Ins then Insert(T,S,P+1) else s[p+1]:=Ch;
        WriteXY(X+P,Y,Copy(S,P+1,Length(S)));
        Inc(p);
       end else if (Length(s)=MaxLen) and (not Ins) then
         begin
          s[p+1]:=ch;
          WriteXY(X+P,Y,T);
          Inc(p);
         end;
      ch:=#0;
      if p>MaxLen-1 then p:=MaxLen-1;
      GotoXY(X+P,Y);
     end else
begin
 case ch of { CTRL-Y }
  #25:   begin
          WriteXY(X,Y,RepeatChar(BackG,Length(S)));
          P:=0;
          S:='';
          GotoXY(X,Y);
         end;
 {Backspace}
 #8: If (P>0) then
  begin
   if (p+1=MaxLen) and (p<length(s)) then Ext:=#83 else
    begin
     Delete(S,P,1);
     Dec(P);
     GotoXY(X+P,Y);
     WriteXY(X+P,Y,Copy(S,P+1,Length(s))+BackG)
    end;
  end;

  #9: begin { Exit on TAB }
       InputStatus:=9;
       Exit:=True;
      end;

 #13: begin
       InputStatus:=13;
       Exit:=True;
      end;
 end; { Case CH of }

 case ext of
 #75: if P>0 then begin
 {Left Arrow}      Dec(P);
                   GotoXY(X+P,Y);
                  end;

 #77: if (P<Length(s)) and (P+1<MaxLen) then begin
 {Right Arrow}             Inc(P);
                           GotoXY(X+P,Y);
                          end;

 #82: Ins:=Not(Ins); {Insert}
 {Delete}
 #83: If P<Length(s) then begin
                           Delete(S,P+1,1);
                           WriteXY(X+P,Y,Copy(S,P+1,Length(s))+BackG);
                          end;

 #71: begin
       p:=0;
       GotoXY(X+P,Y);
      end;

 #79: begin
       p:=Length(s);
       if p>=MaxLen then P:=MaxLen-1;
       GotoXY(X+P,Y);
      end;

 #72,#73,#80,#81,#59..#68:
  begin
   InputStatus:=Ord(Ext);
   Exit:=True;
  end;

 end; {Case of EXT }
end; { if not normal char }

until Exit;
Input:=S;
end;

Procedure WriteXY(x,y: Byte;s: String);
var
 loop:   byte;
begin
for loop:=x to x+length(s)-1 do Mem[$B800:(loop-1)*2+(y-1)*160]:=Ord(S[loop-x+1]);
end;

Procedure WriteXYC(x,y,attr: Byte;s: String);
var
 loop:   byte;
begin
for loop:=x to x+length(s)-1 do
 begin
  Mem[$B800:((loop-1)*2+(y-1)*160)+1]:=Attr;
  Mem[$B800:(loop-1)*2+(y-1)*160]:=Ord(S[loop-x+1]);
 end;
end;

Function CharXY(x,y: byte): byte;
begin
 CharXY:=mem[$B800:(x-1)*2+(y-1)*160];
end;

Function AttrXY(x,y: byte): byte;
begin
 AttrXY:=mem[$B800:((x-1)*2+(y-1)*160)+1];
end;

Procedure SetAttrXY(x,y,Attr: byte);
begin
 mem[$B800:((x-1)*2+(y-1)*160)+1]:=Attr;
end;

Procedure Centre(s: string;y: byte);
begin
WriteXY({1+}(ScreenWidth div 2)-(length(s) div 2),y,s);
end;

Procedure SaveScreen(var Screen: Pointer);
begin
 GetMem(Screen,8000);
 Move(Mem[$B800:0000],Screen^,8000);
end;

Procedure RecallScreen(const Screen: Pointer);
begin
 Move(Screen^,Mem[$B800:0000],8000);
 FreeMem(Screen,8000);
end;

Procedure SetAttr(x,y,len,attr: Byte);
var
 loop           :byte;
begin
 for loop:=x to x+len-1 do mem[$B800:((loop-1)*2+(y-1)*160)+1]:=Attr;
end;

Procedure SetChar(x,y,len: byte;char: String);
var
 loop           :byte;
begin
 for loop:=x to x+len-1 do mem[$B800:(loop-1)*2+(y-1)*160]:=Ord(Char[1]);
end;

Function GetCursor: Word; Assembler;
asm
 mov ah,3
 int $10
 mov ax,cx
end;

Procedure SetCursor(Cursor: Word); Assembler;
asm
 mov ah,$1
 mov cx,Cursor
 int $10
end;

Procedure HideCursor; Assembler;
Asm
 mov ah,1
 mov cx,$2000
 int $10
end;

Procedure NormalCursor; Assembler;
Asm
 mov ah,1
 mov ch,6
 mov cl,7
 int $10
end;

Procedure BlockCursor; Assembler;
Asm
 mov ah,1
 mov ch,0
 mov cl,7
 int $10
end;

procedure GotoXy(X,Y: Byte); Assembler;
asm
 mov   AH,$0F
 int   $10
 mov   AH,$02
 dec   Y
 mov   DH,Y
 dec   X
 mov   DL,X
 int   $10
end;

Function  WhereX: Byte; Assembler;
Asm
  mov ah,3
  mov bh,0      { page 0 }
  int $10
  inc dl
  mov al,dl
end;

Function  WhereY: Byte; Assembler;
Asm
  mov ah,3
  mov bh,0      { page 0 }
  int $10
  inc dh
  mov al,dh
end;

procedure UnCrunch(var Addr1,Addr2; BlkLen:Integer); { UnCrunch TheDraw Object }
begin
  inline (
    $1E/               {       PUSH    DS             ;Save data segment.}
    $C5/$B6/ADDR1/     {       LDS     SI,[BP+Addr1]  ;Source Address}
    $C4/$BE/ADDR2/     {       LES     DI,[BP+Addr2]  ;Destination Addr}
    $8B/$8E/BLKLEN/    {       MOV     CX,[BP+BlkLen] ;Length of block}
    $E3/$5B/           {       JCXZ    Done}
    $8B/$D7/           {       MOV     DX,DI          ;Save X coordinate for later.}
    $33/$C0/           {       XOR     AX,AX          ;Set Current attributes.}
    $FC/               {       CLD}
    $AC/               {LOOPA: LODSB                  ;Get next character.}
    $3C/$20/           {       CMP     AL,32          ;If a control character, jump.}
    $72/$05/           {       JC      ForeGround}
    $AB/               {       STOSW                  ;Save letter on screen.}
    $E2/$F8/           {Next:  LOOP    LOOPA}
    $EB/$4C/           {       JMP     Short Done}
                       {ForeGround:}
    $3C/$10/           {       CMP     AL,16          ;If less than 16, then change the}
    $73/$07/           {       JNC     BackGround     ;foreground color.  Otherwise jump.}
    $80/$E4/$F0/       {       AND     AH,0F0H        ;Strip off old foreground.}
    $0A/$E0/           {       OR      AH,AL}
    $EB/$F1/           {       JMP     Next}
                       {BackGround:}
    $3C/$18/           {       CMP     AL,24          ;If less than 24, then change the}
    $74/$13/           {       JZ      NextLine       ;background color.  If exactly 24,}
    $73/$19/           {       JNC     FlashBitToggle ;then jump down to next line.}
    $2C/$10/           {       SUB     AL,16          ;Otherwise jump to multiple output}
    $02/$C0/           {       ADD     AL,AL          ;routines.}
    $02/$C0/           {       ADD     AL,AL}
    $02/$C0/           {       ADD     AL,AL}
    $02/$C0/           {       ADD     AL,AL}
    $80/$E4/$8F/       {       AND     AH,8FH         ;Strip off old background.}
    $0A/$E0/           {       OR      AH,AL}
    $EB/$DA/           {       JMP     Next}
                       {NextLine:}
    $81/$C2/$A0/$00/   {       ADD     DX,160         ;If equal to 24,}
    $8B/$FA/           {       MOV     DI,DX          ;then jump down to}
    $EB/$D2/           {       JMP     Next           ;the next line.}
                       {FlashBitToggle:}
    $3C/$1B/           {       CMP     AL,27          ;Does user want to toggle the blink}
    $72/$07/           {       JC      MultiOutput    ;attribute?}
    $75/$CC/           {       JNZ     Next}
    $80/$F4/$80/       {       XOR     AH,128         ;Done.}
    $EB/$C7/           {       JMP     Next}
                       {MultiOutput:}
    $3C/$19/           {       CMP     AL,25          ;Set Z flag if multi-space output.}
    $8B/$D9/           {       MOV     BX,CX          ;Save main counter.}
    $AC/               {       LODSB                  ;Get count of number of times}
    $8A/$C8/           {       MOV     CL,AL          ;to display character.}
    $B0/$20/           {       MOV     AL,32}
    $74/$02/           {       JZ      StartOutput    ;Jump here if displaying spaces.}
    $AC/               {       LODSB                  ;Otherwise get character to use.}
    $4B/               {       DEC     BX             ;Adjust main counter.}
                       {StartOutput:}
    $32/$ED/           {       XOR     CH,CH}
    $41/               {       INC     CX}
    $F3/$AB/           {       REP STOSW}
    $8B/$CB/           {       MOV     CX,BX}
    $49/               {       DEC     CX             ;Adjust main counter.}
    $E0/$AA/           {       LOOPNZ  LOOPA          ;Loop if anything else to do...}
    $1F);              {Done:  POP     DS             ;Restore data segment.}
end; {UNCRUNCH}

Procedure GrayBox(X,Y,W,H: Byte;Shadow: Boolean);
var
 loop           :Word;
begin
 for loop:=0 to h-1 do begin
                        SetAttr(X,Y+loop,W,120);
                        SetChar(X,Y+loop,W,' ');
                       end;
 SetAttr(X,Y,W-1,127);
 SetCharXY(X,Y,218);      {  }
 SetChar(X+1,Y,W-2,'');  {  }
 SetCharXY(X+W-1,Y,191);  {  }

 for loop:=1 to h-2 do begin
                        SetAttrXY(X,Y+loop,127); { White }
                        SetCharXY(X,Y+loop,179); {  }
                       { SetAttrXY(X+W-1,Y+loop,120);} { Gray }
                        SetCharXY(X+W-1,Y+loop,179); {  }
                       end;

 SetAttrXY(X,Y+H-1,127);  { White }
 SetCharXY(X,Y+H-1,192);      {  }
 SetChar(X+1,Y+H-1,W-2,'');  {  }
 SetCharXY(X+W-1,Y+H-1,217);  {  }
 if Shadow then
  begin
   SetAttr(X+2,Y+H,W-1,8);
   for Loop:=2 to H-1 do SetAttrXY(X+W,Y+Loop,8);
  end;
end;

Procedure InvGrayBox(X,Y,W,H: Byte);
var
 loop           :Word;
begin
 for loop:=0 to h-1 do begin
                        SetAttr(X,Y+loop,W,120);
                        SetChar(X,Y+loop,W,' ');
                       end;
 SetCharXY(X,Y,218);      {  }
 SetChar(X+1,Y,W-2,'');  {  }
 SetCharXY(X+W-1,Y,191);  {  }
 SetAttr(X+1,Y+H-1,W-1,127);

 SetAttrXY(X+W-1,Y,127); { White }
 for loop:=1 to h-2 do begin
                        SetAttrXY(X+W-1,Y+loop,127); { White }
                        SetCharXY(X,Y+loop,179); {  }
                        SetCharXY(X+W-1,Y+loop,179); {  }
                       end;

 SetCharXY(X,Y+H-1,192);      {  }
 SetChar(X+1,Y+H-1,W-2,'');  {  }
 SetCharXY(X+W-1,Y+H-1,217);  {  }
end;

Procedure GrayMessageBox(S: String; Y:Byte);
begin
if Length(S)>72 then S:=Left(S,72);
GrayBox(38-(Length(S) div 2),Y-1,Length(S)+4,3,True);
Centre(S,Y);
end;

Function MakeElite(S: String): String; (* Only ELiTe makes it possible? *)
var
 SS     :String;
 Ch     :Char;
 Loop   :Word;
begin
S:=Upper(S);
SS:='';
 for loop:=1 to Length(S) do
  begin
   ch:=S[loop];
   case S[loop] of
    'A' :ch:='';
    'B' :ch:='';
    'C' :ch:='';
    'D' :ch:='D';
    'E' :ch:='';
    'F' :ch:='';
    'G' :ch:='';
    'H' :ch:='h';
    'I' :ch:='';
    'J' :ch:='';
    'K' :ch:='K';
    'L' :ch:='';
    'M' :ch:='M';
    'N' :ch:='';
    'O' :ch:='';
    'P' :ch:='';
    'Q' :ch:='Q';
    'R' :ch:='';
    'S' :ch:='';
    'T' :ch:='';
    'U' :ch:='';
    'V' :ch:='';
    'W' :ch:='W';
    'X' :ch:='x';
    'Y' :ch:='';
    'Z' :ch:='z';
    '!' :ch:='';
    '?' :ch:='';
  end;
  SS:=SS+CH;
 end;
MakeElite:=SS;
end;

Procedure FancyAnsiWrite(X,Y,C1,C2,C3,C4: Byte;S: String);
var
 loop   :Word;
 COL    :Byte;
begin
 for loop:=1 to Length(S) do
  begin
   COL:=C4;
   if loop=1 then Col:=c1;
   if loop=2 then Col:=c2;
   if loop=3 then Col:=c3;

   if loop=length(s) then Col:=c1;
   if loop=length(s)-1 then Col:=c2;
   if loop=length(s)-2 then Col:=c3;
   SetAttrXY(X+loop-1,Y,COL);
  end;
 WriteXY(X,Y,S);
end;

procedure Set50Lines; Assembler;
asm
 mov ax,1202h
 mov bl,30h
 int 10h
 mov ax,3
 int 10h
 mov ax,1112h
 xor bl, bl
 int 10h
end;

Procedure NCButton(nr: byte;s: string);
var
 sh,
 loop:   byte;

begin
 SH:=ScreenHeight+1;
 SetAttrXY((nr-1)*8+1,SH,7);
 SetAttrXY((nr-1)*8+2,SH,7);
if nr<10 then begin
 SetCharXY((nr-1)*8+1,SH,48+nr);
 for loop:=2 to 7 do SetAttrXY((nr-1)*8+loop,SH,48);
 for loop:=1 to length(s) do SetCharXY((nr-1)*8+loop+1,SH,ord(s[loop]));
 end else
     begin
      SetCharXY(73,SH,49);
      SetCharXY(74,SH,48);
      for loop:=1 to 8 do SetAttrXY(74+loop,SH,48);
      for loop:=1 to length(s) do SetCharXY(74+loop,SH,ord(s[loop]));
     end;
end;

Procedure NCBottomLine(s1,s2,s3,s4,s5,s6,s7,s8,s9,s10: string);
begin
 NCButton(1,s1); NCButton(2,s2); NCButton(3,s3); NCButton(4,s4);
 NCButton(5,s5); NCButton(6,s6); NCButton(7,s7); NCButton(8,s8);
 NCButton(9,s9); NCButton(10,s10);
end;

Procedure GrayBox2(X,Y,W,H,HeadOfs,Attr: Byte;const Header: String; Shadow: Boolean);
var
 Loop   :Byte;
begin
 GrayBox(X,Y,W,H,Shadow);
 WriteXYC(X+1+HeadOfs,Y,120,'=[');
 WriteXYC(X+4+HeadOfs,Y,Attr,Header);
 WriteXYC(X+4+HeadOfs+Length(Header),Y,120,']=');
end;

Procedure InvGrayBox2(X,Y,W,H,HeadOfs,Attr: Byte;const Header: String);
begin
 InvGrayBox(X,Y,W,H);
 WriteXYC(X+1+HeadOfs,Y,127,'=[');
 WriteXYC(X+4+HeadOfs,Y,Attr,Header);
 WriteXYC(X+4+HeadOfs+Length(Header),Y,127,']=');
end;

Procedure ChooseAsciiSet(X,Y: Byte;var AsciiSet: String);
var
 TempScreen     :Pointer;
 OldPos,
 CurrPos,
 OldXX,OldYY,
 XX,YY          :Byte;
 Ch             :Char;
 HackSet        :Array[0..255] of Boolean;

Procedure Update(Pos,EX,EY,TrueAttr,FalseAttr: Byte);
begin
 if HackSet[Pos] then SetAttr(X+(EX*3)-2,Y+EY,3,TrueAttr) else SetAttr(X+(EX*3)-2,Y+EY,3,FalseAttr);
end;

begin
 SaveScreen(TempScreen);
 GrayBox2(X,Y,16*3+2,18,1,58,' Define Valid Characters ',True);
 CurrPos:=0;

 for XX:=0 to 255 do if Instr(AsciiSet,Chr(XX),1)>0 then HackSet[XX]:=True else HackSet[XX]:=False;

 for YY:=1 to 16 do
  for XX:=1 to 16 do
   begin
    Inc(CurrPos);
    if CurrPos=33 then WriteXY(X+(XX*3)-1,Y+YY,'') else WriteXY(X+(XX*3)-1,Y+YY,Chr(CurrPos-1));
    Update(CurrPos-1,XX,YY,127,120);
   end;
 CurrPos:=0;
 XX:=CurrPos mod 16+1;
 YY:=CurrPos div 16+1;
 SetAttr(X+(XX*3)-2,Y+YY,3,63);
 REPEAT
  Ch:=ReadKey;
  if ch=#0 then begin
   Ch:=ReadKey;
   OldPos:=CurrPos;
    if ch=RightKey then if XX<16 then Inc(CurrPos);
    if ch=LeftKey  then if XX>1  then Dec(CurrPos);
    if ch=DownKey  then if YY<16 then Inc(CurrPos,16);
    if ch=UpKey    then if YY>1  then Dec(CurrPos,16);
   if OldPos<>CurrPos then
    begin
     XX:=OldPos mod 16+1;
     YY:=OldPos div 16+1;
     Update(OldPos,XX,YY,127,120);
     XX:=CurrPos mod 16+1;
     YY:=CurrPos div 16+1;
     Update(CurrPos,XX,YY,63,56);
    end;
    end else begin { If NOT Extended }
     if Ch=ENTER then
      begin
       HackSet[CurrPos]:=NOT HackSet[CurrPos];
       Update(CurrPos,XX,YY,63,56);
      end;
   end;
 UNTIL Ch=ESC;

AsciiSet:='';
{Cannot Choose Character Zero }
for XX:=1 to 255 do if HackSet[XX] then AsciiSet:=AsciiSet+Chr(XX);

RecallScreen(TempScreen);
end;

Procedure Delay(ms: Word); Assembler;
Asm
 mov ax,1000;
 mul ms;
 mov cx,dx;
 mov dx,ax;
 mov ah,$86;
 int $15;
end;

Procedure MessageScroller(X,Y,W,H: Byte;var ScrollText: Array of Char);
var
 OldX,OldY      :Byte;
 Tid            :Byte;
 Done           :Boolean;
 Loop           :Word;
 Ch             :Char;

begin
 TextAttr:=127;
 Window(X,Y,X+W-2,Y+H-1);
 loop:=0;
 Done:=False;
repeat
 tid:=100;

 if ScrollText[loop]<#10 then TextColor(6+Ord(ScrollText[loop])) else
 if ScrollText[loop]='' then Hackutil.Delay(1000) else
  begin
   Write(ScrollText[loop]);

   if (ScrollText[loop]>#9) and (ScrollText[loop]<>#13) then
    begin
     OldX:=WhereX;
     OldY:=WhereY;
     WriteXYC(WhereX,WhereY,127,'');
    end;

   if KeyPressed then
    begin
     ch:=ReadKey;
     if ch=#0 then
      begin
       ch:=ReadKey;
       if ch=DownKey then tid:=10;
      end else Done:=True;
    end;

   if ScrollText[loop]>#31 then
    begin
     if ScrollText[loop]=#32 then Hackutil.Delay(Tid) else
         Hackutil.Delay(Tid+Random(Tid));
    end;

   if (ScrollText[loop]>#9) and (ScrollText[loop]<>#13) then
    begin
     WriteXY(OldX,OldY,' ');
     GotoXY(OldX,OldY);
    end;
  end;
 Inc(loop);
 if loop=SizeOf(ScrollText) then loop:=1;
 until Done;
Ch:=#0;
Window(1,1,ScreenWidth,ScreenHeight+1);
Done:=False;
end;

Function AskBoolean(X,Y: Byte;Header,T1,T2: String): Boolean;
var
 OldPos,
 Pos,
 Wid,
 Ofs       :Byte;
 Ch        :Char;

begin
 Wid:=Max(Length(Header)+2,Length(T1)+Length(T2))+9;
 GrayBox2(X,Y,Wid,5,1,29,Header,True);
 Ofs:=(Wid div 2)-((Length(T1)+Length(T2)+5) div 2);
 WriteXY(X+Ofs+1,Y+2,T1);
 WriteXY(X+Ofs+Length(T1)+4,Y+2,T2);
 Pos:=1;
 Repeat
  if Pos=1 then SetAttr(X+Ofs,Y+2,Length(T1)+2,30);
  Ch:=ReadKey;
   if ch=#0 then begin
    Ch:=ReadKey;
    OldPos:=Pos;
    if ch=LeftKey then Pos:=1;
    if ch=RightKey then Pos:=2;
    if Pos<>OldPos then begin
     if Pos=1 then
      begin
       SetAttr(X+Ofs,Y+2,Length(T1)+2,30);
       SetAttr(X+Ofs+1+Length(T1)+2,Y+2,Length(T2)+2,120);
     end else begin
       SetAttr(X+Ofs,Y+2,Length(T1)+2,120);
       SetAttr(X+Ofs+1+Length(T1)+2,Y+2,Length(T2)+2,30);
     end;
    end;
   end;
 Until Ch=Enter;
Ch:=#0;
if Pos=1 then AskBoolean:=True else AskBoolean:=False;
end;

end.
